﻿using HPPH;
using HPPH.System.Drawing;
using StableDiffusion.NET;
using System.Windows;
using System.IO;
using System.Drawing;
using System.Globalization;
using System.Windows.Media.Imaging;

namespace LLM_Doghouse
{
    internal class AimGen
    {
        private string strMdl = "";
        private string strVae = "";
        private string strEmb = "";
        public string ModelPath
        {
            get => strMdl; set => strMdl = value;
        }
        public string VaePath
        {
            get => strVae; set => strVae = value;
        }
        public string EmbPath
        {
            get => strEmb; set => strEmb = value;
        }

        public AimGen()
        {

        }
        public object? AimGenRun(string prompt)
        {
            const int intWidth = 256;
            const int intHeight = 256;
            const float fltScale = 11f;
            const int intSteps = 12;
            IImage objImage;
            try
            {
                if (CheckItem()) return null;
                //Load Model
                DiffusionModel sdModel;
                if (strVae != "" && strEmb != "")
                    sdModel = ModelBuilder.StableDiffusion(strMdl).WithMultithreading().WithVae(strVae).WithSchedule(Schedule.Karras).WithEmbeddingSupport(strEmb).Build();
                else if (strVae != "" && strEmb == "")
                    sdModel = ModelBuilder.StableDiffusion(strMdl).WithMultithreading().WithVae(strVae).WithSchedule(Schedule.Karras).Build();
                else if (strVae == "" && strEmb != "")
                    sdModel = ModelBuilder.StableDiffusion(strMdl).WithMultithreading().WithSchedule(Schedule.Karras).WithEmbeddingSupport(strEmb).Build();
                else
                    sdModel = ModelBuilder.StableDiffusion(strMdl).WithMultithreading().WithSchedule(Schedule.Karras).Build();

                string antiprompt = "(worst quality:2) , (low quality:2) , (normal quality:2) , lowres, ugly face, unclear eyes, bad mouth, bad tooth, bad anatomy, extra legs, (bad fingers, bad hands, missing fingers), negative_hand-neg";
                long lngSeed = 0;

                //Seed Random
                Random rSeed = new Random();
                lngSeed = rSeed.Next(0, int.MaxValue);
                DiffusionParameter parameter = sdModel.GetDefaultParameter()
                                                        .WithNegativePrompt(antiprompt)
                                                        .WithSize(intWidth, intHeight)
                                                        .WithSteps(intSteps)
                                                        .WithSeed(lngSeed)
                                                        .WithSampler(Sampler.DPMPP2Mv2)
                                                        .WithCfg(fltScale);

                objImage = sdModel.TextToImage(prompt, parameter);
                //File.WriteAllBytes(imgPath, objImage.ToPng());
                var imgRtn = IImage2bitmap(objImage);
                return(imgRtn);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "AimGen", MessageBoxButton.OK, MessageBoxImage.Error);
                return null;
            }
        }
        public bool CheckItem(bool mb = true)
        {
            if (strMdl.Trim() == "")
            {
                if (mb) MessageBox.Show("Stable Diffusion Model file does not exist.", "AimGen", MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }
            if (strMdl.Trim() != "")
            {
                if (!File.Exists(strMdl))
                {
                    if (mb) MessageBox.Show("Stable Diffusion Model file does not exist.", "AimGen", MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }
            if (strVae.Trim() != "")
            {
                if (!File.Exists(strVae))
                {
                    if (mb) MessageBox.Show("Vae file does not exist.", "AimGen", MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }
            if (strEmb.Trim() != "")
            {
                if (!File.Exists(strEmb))
                {
                    if (mb) MessageBox.Show("Embedding file does not exist.", "AimGen", MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }
            return (false);
        }

        public object? IImage2bitmap(IImage iimage)
        {
            using Bitmap bitmap = iimage.ToBitmap();
            if (bitmap == null) return null;

            using MemoryStream ms = new();
            bitmap.Save(ms, System.Drawing.Imaging.ImageFormat.Bmp);
            ms.Position = 0;

            BitmapImage bitmapImage = new();
            bitmapImage.BeginInit();
            bitmapImage.StreamSource = ms;
            bitmapImage.CacheOption = BitmapCacheOption.OnLoad;
            bitmapImage.EndInit();

            return bitmapImage;
        }

    }
}
