﻿using LLama.Common;
using LLama.Sampling;
using LLama;
using System.Data.SQLite;
using System.Data;
using System.Diagnostics;
using System.IO;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using DSharpPlus.Entities;
using DSharpPlus.VoiceNext;
using DSharpPlus;
using Windows.Media.SpeechRecognition;
using MaterialDesignThemes.Wpf;
using System.Windows.Threading;
using DSharpPlus.EventArgs;
using System.Text.RegularExpressions;
using System.Media;
using Microsoft.Win32;
using System.ComponentModel;
using MaterialDesignColors;

namespace LLM_Doghouse
{
    public partial class MainForm : Window
    {
        private string DatabasePath = GetStartupPath() + @"\ChatDB.db";
        private int silenceTimerCnt = 0;    //Timerカウント
        private bool Wt = false;            //待ちフラグ
        private ChatHistoryDB chtDB;        //チャットログシステム
        private ModelParams modPara;
        private LLamaWeights llmWeit;
        private LLamaContext llmContx;
        private InteractiveExecutor itrEx;
        private ChatHistory chtHis;
        private ChatSession chtSess;
        private LLamaTransforms.KeywordTextOutputStreamTransform? llmHidewd;
        private InferenceParams infPara;
        private SpeechRecognizer recognizer;
        private uint intVvx = 0;
        private bool Sd = false;
        private bool Sm = false;
        private bool Lv = false;
        private string Sdprompt = "";
        private string strTkn = "";
        private ulong lngCid = 0;
        private bool booMic = false;
        private bool booSav = false;
        private const string strAI = "AI";
        private Dictionary<string, AuthorRole>? Roles = new Dictionary<string, AuthorRole> { { "System", AuthorRole.System }, { "User", AuthorRole.User }, { strAI, AuthorRole.Assistant } };
        //Discord Bot変数
        private DiscordConfiguration dcconfig;
        private DiscordClient dcclient;
        private DiscordActivity dcstatus;
        private VoiceNextConnection dcvoiceCon;
        //VOICEVOX
        private Core core;
        //Emotion Image
        private string[] strEmtPath = { "imgUsuWhite.png", "imgSmlWhite.png", "imgAfcWhite.png", "imgSkpWhite.png", "imgCncWhite.png", "imgNegWhite.png" };
        private System.Timers.Timer silenceTimer;
        private const uint itrvl = 7000;
        //DataTable
        private DataTable dtCht;
        private DataTable dtMng;
        //ControlValue
        private int intCboSyt = 0;
        private string strCboCvo = "";
        private uint intCboVvx = 0;

        public MainForm()
        {
            InitializeComponent();
        }
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            ContentSelector.SelectedIndex = int.Parse(((System.Windows.Controls.Button)sender).Tag.ToString()??"");
            Menu_Button_Click();
        }
        private void Menu_Button_Click()
        {
            switch (ContentSelector.SelectedIndex)
            {
                case 0:
                    int intSavCh = 0;
                    if (cboCht.Items.Count > 0)
                    {
                        intSavCh = cboCht.SelectedIndex;
                    }
                    cboCht.ItemsSource = ((IListSource)mng()).GetList();
                    if (cboCht.Items.Count == 0)
                    {
                        btnLoad.IsEnabled = false;
                        cboCht.IsEnabled = false;
                    }
                    else
                    {
                        btnLoad.IsEnabled = true;
                        cboCht.IsEnabled = true;
                        cboCht.SelectedIndex = intSavCh;
                    }
                    //システム環境読み込み
                    InitSettingSys();
                    break;
                case 1:
                    InitSettingEd();
                    break;
                case 2:
                    InitSettingSys();
                    break;
            }
        }
        private void OpenMenu_Click(object sender, RoutedEventArgs e)
        {
            DrawerHost.IsLeftDrawerOpen = OpenMenu.IsChecked ?? false;
        }
        private void DrawerHost_DrawerClosing(object sender, MaterialDesignThemes.Wpf.DrawerClosingEventArgs e)
        {
            DrawerHost.IsLeftDrawerOpen = OpenMenu.IsChecked ?? false;
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            System.Windows.Application.Current.Shutdown();
            WindowSaveSetting();
        }

        private void Window_Initialized(object sender, EventArgs e)
        {
        }


        private void WindowLoadSetting()
        {
            try
            {
                this.Top = Properties.Settings.Default.Top;
                this.Left = Properties.Settings.Default.Left;
                this.Height = Properties.Settings.Default.Height;
                this.Width = Properties.Settings.Default.Width;
                if (Properties.Settings.Default.Maximized)
                {
                    WindowState = WindowState.Maximized;
                }
                chkMod.IsChecked = Properties.Settings.Default.BaseTheme;
                if (Properties.Settings.Default.PrimeryColor == -1)
                    cboPrm.SelectedIndex = 2;
                else
                    cboPrm.SelectedIndex = Properties.Settings.Default.PrimeryColor;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void WindowSaveSetting()
        {
            try
            {
                if (cboPrm.SelectedIndex > -1)
                {
                    if (WindowState == WindowState.Maximized)
                    {
                        Properties.Settings.Default.Top = RestoreBounds.Top;
                        Properties.Settings.Default.Left = RestoreBounds.Left;
                        Properties.Settings.Default.Height = RestoreBounds.Height;
                        Properties.Settings.Default.Width = RestoreBounds.Width;
                        Properties.Settings.Default.Maximized = true;
                    }
                    else
                    {
                        Properties.Settings.Default.Top = this.Top;
                        Properties.Settings.Default.Left = this.Left;
                        Properties.Settings.Default.Height = this.Height;
                        Properties.Settings.Default.Width = this.Width;
                        Properties.Settings.Default.Maximized = false;
                    }
                    Properties.Settings.Default.BaseTheme = chkMod.IsChecked.Value;
                    Properties.Settings.Default.PrimeryColor = cboPrm.SelectedIndex;
                    Properties.Settings.Default.Save();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }


        private async void Window_Loaded(object sender, RoutedEventArgs e)
        {
            SetEnabled_ChatGroup(false);
            btnEject.IsEnabled = false;
            lblInfo.Visibility = Visibility.Hidden;
            picDc.Visibility = Visibility.Hidden;
            picSm.Visibility = Visibility.Hidden;
            picSd.Visibility = Visibility.Hidden;
            picLv.Visibility = Visibility.Hidden;
            WindowLoadSetting();

            try
            {
                cboCht.ItemsSource = ((IListSource)mng()).GetList();
                if (cboCht.Items.Count==0)
                {
                    btnLoad.IsEnabled = false;
                    cboCht.IsEnabled = false;
                }
                else cboCht.SelectedIndex = 0;
                cboCvo.ItemsSource = ((IListSource)cvo()).GetList();
                cboSyt.ItemsSource = ((IListSource)syt()).GetList();
                cboVvx.ItemsSource = ((IListSource)vvx()).GetList();
                // SpeechRecognitionの設定
                recognizer = new SpeechRecognizer();
                // Set timeout settings.
                recognizer.Timeouts.InitialSilenceTimeout = TimeSpan.FromSeconds(6.0); // (認識結果が生成されるまでの) 無音を検出し、音声入力が続かないと見なす時間の長さ。
                recognizer.Timeouts.BabbleTimeout = TimeSpan.FromSeconds(4.0);         //認識できないサウンド (雑音) のリッスンを継続し、音声入力が終了したと見なし、認識処理を終了するまでの時間の長さ。
                recognizer.Timeouts.EndSilenceTimeout = TimeSpan.FromSeconds(1.2);     //(認識結果が生成された後の) 無音を検出し、音声入力が終了したと見なす時間の長さ。
                await recognizer.CompileConstraintsAsync();

                recognizer.ContinuousRecognitionSession.ResultGenerated += ContinuousRecognitionSession_ResultGenerated;
                //AI会話タイムアウト
                recognizer.ContinuousRecognitionSession.Completed += ContinuousRecognitionSession_Completed;
                //GPU使用メモリ編集
                GPU_UsageMemory();

                //システム環境読み込み
                InitSettingSys();

                if (cboCht.Items.Count > 0)
                {
                    //引数起動の場合はロードを行う
                    string[] cmds = System.Environment.GetCommandLineArgs();
                    //コマンドライン引数を列挙する
                    int intNo = 0;
                    foreach (string cmd in cmds)
                    {
                        if (cmd.StartsWith("/ch"))
                        {
                            if (int.TryParse(cmd.Replace("/ch", ""), out intNo))
                            {
                                if (intNo > 0)
                                {
                                    cboCht.SelectedValue = intNo;
                                    if (cboCht.SelectedItem == null) break;
                                    if (await LoadLLM()) LoadSetting();
                                    break;
                                }
                            }
                        }
                    }
                }
                //タイマー定義
                silenceTimer = new System.Timers.Timer(itrvl);
                silenceTimer.Elapsed  += silenceTimer_Tick;
                //コマンド起動モード
                if (cboCht.Items.Count > 0)
                {
                    //引数起動の場合はロードを行う
                    string[] cmds = System.Environment.GetCommandLineArgs();
                    //コマンドライン引数を列挙する
                    int intNo = 0;
                    foreach (string cmd in cmds)
                    {
                        if (cmd.StartsWith("/ch"))
                        {
                            if (int.TryParse(cmd.Replace("/ch", ""), out intNo))
                            {
                                if (intNo > 0)
                                {
                                    cboCht.SelectedValue = intNo;
                                    if (cboCht.SelectedItem == null) break;
                                    btnLoad_Click(sender, e);
                                    break;
                                }
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                System.Windows.Application.Current.Shutdown();
            }
        }
        private async void btnLoad_Click(object sender, RoutedEventArgs e)
        {
            SetEnabled_LoadGroup(false);
            if (await LoadLLM())
            {
                btnEject_Click(sender, e);
                return;
            }
            LoadSetting();
        }

        private async Task<bool> LoadLLM()
        {
            int intGpu = 0;
            uint intCtx = 0;
            float fltTmp = 0f;
            try
            {
                //初期化処理
                ClearItems();
                //編集画面読み込み
                InitSettingEd();

                if (Lv) dvwMsg.AllowDrop = true;
                else dvwMsg.AllowDrop = false;
                string strTable = $"ch{cboCht.SelectedValue}";
                //パラメータチェック
                if (!File.Exists(txtMdl.Text))
                {
                    await MessageBox_Show("LLM Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return true;
                }
                if (!int.TryParse(txtGpu.Text, out intGpu)) intGpu = 0;
                if (intGpu == 0) intGpu = 5;
                if (!uint.TryParse(txtCtx.Text, out intCtx)) intCtx = 0;
                if (intCtx == 0) intCtx = 512;
                if (!float.TryParse(txtTmp.Text, out fltTmp)) fltTmp = 0f;
                lblInfo.Content = "Now Loading The History...";
                lblInfo.Visibility = Visibility.Visible;
                DoEvents();
                //チャットログ要約処理
                if (Sm)
                {
                    lblInfo.Content = "Now Summarizing The History...";
                    lblInfo.Visibility = Visibility.Visible;
                    DoEvents();
                    var sum = new HistorySummary(DatabasePath);
                    sum.ModelPath = txtMdl_s.Text;
                    sum.ContextSize = uint.Parse(txtCtx_s.Text);
                    sum.GpuLayerCount = int.Parse(txtGpu_s.Text);
                    sum.Temperature = float.Parse(txtTmp_s.Text);
                    await sum.Run(intCtx, strTable);
                    sum = null;
                }
                else
                {
                    lblInfo.Content = "Now Truncating The History...";
                    lblInfo.Visibility = Visibility.Visible;
                    DoEvents();
                    var sum = new HistorySummary(DatabasePath);
                    sum.Truncate(intCtx, strTable);
                    sum = null;
                }
                //LLMモデルのロードとパラメータの設定
                lblInfo.Content = "Now Loading The History...";
                lblInfo.Visibility = Visibility.Visible;
                DoEvents();
                modPara = new ModelParams(txtMdl.Text)
                {
                    ContextSize = intCtx,
                    GpuLayerCount = intGpu,
                };
                llmWeit = LLamaWeights.LoadFromFile(modPara);
                llmContx = llmWeit.CreateContext(modPara);
                itrEx = new(llmContx);
                //チャットログを読み込みます。
                chtHis = new ChatHistory();
                chtDB = new ChatHistoryDB(DatabasePath, chtHis, strTable, txtSys.Text);
                chtSess = new(itrEx, chtHis);
                llmHidewd = new LLamaTransforms.KeywordTextOutputStreamTransform(["User: ", "Assistant: "]);
                chtSess.WithOutputTransform(llmHidewd);
                infPara = new InferenceParams()
                {
                    SamplingPipeline = new DefaultSamplingPipeline()
                    {
                        Temperature = fltTmp,
                        Seed = 1337,
                    },
                    AntiPrompts = ["User:"],
                    MaxTokens = 256,
                };
                //VOICEVOX Coreをここで読み込んでおく
                InitVoicevox(uint.Parse(cboVvx.SelectedValue.ToString()));
                //GPU使用メモリ編集
                GPU_UsageMemory();
                //Discord Bot Enabledは、Discord Botを起動する
                if (chkBot.IsChecked.Value)
                {
                    strTkn = txtTkn.Text;
                    if (!ulong.TryParse(txtCid.Text, out lngCid)) lngCid = 0;
                    DiscordBot();
                }

                lblInfo.Visibility = Visibility.Hidden;
                txtMsg.Focus();
                return false;
            }
            catch (Exception ex)
            {
                lblInfo.Visibility= Visibility.Hidden;
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return true;
            }
        }
        public static string GetStartupPath()
        {
            return System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
        }
        private async void ClearItems()
        {
            //初期化処理
            chtDB = null;
            modPara = null;
            if (llmWeit != null) llmWeit.Dispose();
            llmWeit = null;
            if (llmContx != null) llmContx.Dispose();
            llmContx = null;
            itrEx = null;
            chtHis = null;
            chtSess = null;
            llmHidewd = null;
            infPara = null;
            if (core != null) core.Dispose();
            core = null;

            if (chkBot.IsChecked.Value)
            {
                //Discord Event Stop & Clear
                if (dcclient != null)
                {
                    dcclient.MessageCreated -= OnMessageCreated;
                    dcclient.Ready -= OnClientReady;
                    dcclient.GuildAvailable -= OnGuildAvailable;
                    dcclient.VoiceStateUpdated -= OnVoiceStateUpdated;
                    if (dcvoiceCon is not null) dcvoiceCon.Disconnect();
                    await dcclient.DisconnectAsync();
                    dcclient.Dispose();
                    picDc.Visibility = Visibility.Hidden;
                    dcclient = null;
                }
            }
        }
        private async Task Chat(string strUserInput)
        {
            try
            {
                if (!Wt)
                {
                    Wt = true;
                    ChatHistory.Message msgText = new(AuthorRole.User, strUserInput);
                    WriteHistory(AuthorRole.User, strUserInput);
                    Dispatcher.Invoke(dvwMsg_Refresh);
                    // 回答の表示
                    Debug.WriteLine("dbg=(1)");
                    string strMsg = "";
                    await foreach (string strText in chtSess.ChatAsync(msgText, infPara)) strMsg += strText;
                    //発信するときは「User:」や「Assistant:」を抜く
                    string strSndmsg = EditAiMsg(strMsg);
                    //画像生成キーワード探索
                    if (strMsg.IndexOf("[")  != -1)
                    {
                        var rgxRtn = new Regex(@"\[(.+?)\]").Matches(strMsg);
                        if (rgxRtn.Count > 0)
                        {
                            Sdprompt = rgxRtn[0].Value.Replace("[", "").Replace("]", "").Trim();
                        }
                    }
                    Debug.WriteLine("dbg=(2)");
                    WriteHistory(AuthorRole.Assistant, strSndmsg);
                    Debug.WriteLine("dbg=(3)");
                    Dispatcher.Invoke(dvwMsg_Refresh);
                    Debug.WriteLine("dbg=(4)");
                    if (booMic)
                    {
                        Debug.WriteLine("dbg=(5)");
                        SpeechSynthesis(strSndmsg); //音声ソフト実行
                        Thread.Sleep(3000);
                    }
                    Wt = false;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private string EditAiMsg(string strMsg)
        {
            return strMsg.Replace("User:", "").Replace("Assistant:", "").Replace("assistant:", "").Trim();
        }

        private async void ContinuousRecognitionSession_ResultGenerated(SpeechContinuousRecognitionSession sender, SpeechContinuousRecognitionResultGeneratedEventArgs e)
        {
            //AI会話
            if (!Wt && booMic)
            {
                silenceTimerCnt = 0;
                silenceTimer.Stop();
                await Chat(e.Result.Text.Replace("MK", "マンコ").Replace("TK", "チンコ").Replace("TP", "チンポ"));
                silenceTimer.Start();
            }
        }
        private async void ContinuousRecognitionSession_Completed(SpeechContinuousRecognitionSession sender, SpeechContinuousRecognitionCompletedEventArgs e)
        {
            if (booMic)
            {
                if (recognizer.State == SpeechRecognizerState.Idle)
                {
                    await recognizer.ContinuousRecognitionSession.StartAsync();
                }
            }
        }

        private DataTable mng()
        {
            try
            {
                DataTable dt = new DataTable();
                using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
                {
                    SQLiteDataAdapter adp = new SQLiteDataAdapter("SELECT * from mng order by no;", con);
                    adp.Fill(dt);
                }
                return dt;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return null;
            }
        }
        private DataTable ch()
        {
            try
            {
                DataTable dt = new DataTable();
                SQLiteDataAdapter adp;
                using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
                {
                    adp = new SQLiteDataAdapter($"SELECT replace(id,'Assistant','{strAI}') id,replace(replace(replace(replace(replace(msg,'User',''),'Assistant',''),char(13, 10),''),char(10),''),':','') msg,sq FROM ch{cboCht.SelectedValue} where sq>3 and flg=0 order by sq;", con);
                    adp.Fill(dt);
                }
                return dt;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return null;
            }
        }
        private DataTable syt()
        {
            DataTable dt = new DataTable();
            using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
            {
                SQLiteDataAdapter adp = new SQLiteDataAdapter("SELECT * from syt order by no;", con);
                adp.Fill(dt);
            }
            return dt;
        }
        private DataTable cvo()
        {
            DataTable dt = new DataTable();
            using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
            {
                SQLiteDataAdapter adp = new SQLiteDataAdapter("SELECT * from cvo order by no;", con);
                adp.Fill(dt);
            }
            return dt;
        }
        private DataTable vvx()
        {
            DataTable dt = new DataTable();
            using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
            {
                SQLiteDataAdapter adp = new SQLiteDataAdapter("SELECT * from vvx order by no;", con);
                adp.Fill(dt);
            }
            return dt;
        }

        private void LoadSetting()
        {
            dtCht = ch();
            dvwMsg.DataContext = dtCht;
            dvwMsg.Items.Refresh();
            dvwMsg_Refresh();

            SetEnabled_ChatGroup(true);
            chkMic.IsChecked = false;
            booMic = false;
            txtMsg.Focus();
        }
        private void WriteHistory(AuthorRole aurID, string strUserInput)
        {
            try
            {
                DataRow dr;
                long lngRtn = 0;
                lngRtn = chtDB.WriteHistory(aurID, (aurID == AuthorRole.User ? "User: " : "") + strUserInput);
                dr = dtCht.NewRow();
                dr[0] = Roles.FirstOrDefault(v => v.Value.Equals(aurID)).Key;
                dr[1] = strUserInput;
                dr[2] = lngRtn;
                dtCht.Rows.Add(dr);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
        private void dvwMsg_Refresh()
        {
            dvwMsg.Items.Refresh();
            if (dvwMsg.Items.Count <= 1) return;
            dvwMsg.ScrollIntoView(dvwMsg.Items.GetItemAt(dvwMsg.Items.Count - 1));

            DataRow dr = dtCht.Rows[dtCht.Rows.Count - 1];
            string strId = dr[0].ToString();

            if (strId != null)
            {
                if (strId == strAI)
                {
                    string strMsg = dr[1].ToString();
                    picEmt.Source = SelectEmtImg(SearchEmotion(strMsg));
                    DoEvents();
                }
            }
        }
        private ImageSource SelectEmtImg(int ix)
        {
            ImageSource imgRtn;
            switch (ix)
            {
                case 1:
                    imgRtn = picSml.ImageSource;
                    break;
                case 2:
                    imgRtn = picAfc.ImageSource;
                    break;
                case 3:
                    imgRtn = picSkp.ImageSource;
                    break;
                case 4:
                    imgRtn = picCnc.ImageSource;
                    break;
                case 5:
                    imgRtn = picNeg.ImageSource;
                    break;
                default:
                    imgRtn = picUsu.ImageSource;
                    break;
            }
            return imgRtn;
        }
        private void DoEvents()
        {
            DispatcherFrame frame = new DispatcherFrame();
            var callback = new DispatcherOperationCallback(obj =>
            {
                ((DispatcherFrame)obj).Continue = false;
                return null;
            });
            Dispatcher.CurrentDispatcher.BeginInvoke(DispatcherPriority.Background, callback, frame);
            Dispatcher.PushFrame(frame);
        }
        private async Task<bool> CheckEd()
        {
            //パラメータチェック
            if (txtNam.Text.IndexOf("\'")>0 || txtNam.Text.IndexOf("\"")>0)
            {
                await MessageBox_Show("Chat name contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }
            if (txtNam.Text.Trim() == "")
            {
                await MessageBox_Show("Chat name not entered.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }
            if (txtSys.Text.IndexOf("\'")>0 || txtSys.Text.IndexOf("\"")>0)
            {
                await MessageBox_Show("System Prompt contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }
            if (txtMdl.Text.IndexOf("\'")>0 || txtMdl.Text.IndexOf("\"")>0)
            {
                await MessageBox_Show("LLM Path contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }

            int intCtx = 0;
            int intGpu = 0;
            float fltTmp = 0.0f;
            if (!int.TryParse(txtCtx.Text, out intCtx)) intCtx = 512;
            if (intCtx == 0) intCtx = 512;
            if (!float.TryParse(txtTmp.Text, out fltTmp)) fltTmp = 0.5f;
            if (fltTmp == 0) fltTmp = 0.5f;
            if (!int.TryParse(txtGpu.Text, out intGpu)) intGpu = 5;
            if (intGpu == 0) intGpu = 5;

            txtCtx.Text = intCtx.ToString();
            txtTmp.Text = fltTmp.ToString("F");
            txtGpu.Text = intGpu.ToString();

            if (!File.Exists(txtMdl.Text))
            {
                await MessageBox_Show("LLM Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                txtMdl.Focus();
                return (true);
            }

            if (chkBot.IsChecked.Value)
            {
                if (txtTkn.Text == "")
                {
                    await MessageBox_Show("Discord Token contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    txtTkn.Focus();
                    return (true);
                }
            }
            return (false);
        }
        private async Task<bool> CheckSm(bool mb = true)
        {
            //パラメータチェック
            if (txtMdl_s.Text.IndexOf("\'")>0 || txtMdl.Text.IndexOf("\"")>0)
            {
                if (mb) await MessageBox_Show("LLM Path contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }

            if (txtMdl_s.Text.Trim() == "")
            {
                if (!mb) return (true); //メッセージBOX非表示モードの時はエラーにする
            }
            else
            {
                if (!File.Exists(txtMdl_s.Text))
                {
                    if (mb) await MessageBox_Show("LLM Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }

            uint intCtx = 0;
            int intGpu = 0;
            float fltTmp = 0.0f;
            if (!uint.TryParse(txtCtx_s.Text, out intCtx)) intCtx = 0;
            if (intCtx == 0) intCtx = 512;
            if (!float.TryParse(txtTmp_s.Text, out fltTmp)) fltTmp = 0.0f;
            if (!int.TryParse(txtGpu_s.Text, out intGpu)) intGpu = 0;
            if (intGpu == 0) intGpu = 5;
            txtCtx_s.Text = intCtx.ToString();
            txtTmp_s.Text = fltTmp.ToString("F");
            txtGpu_s.Text = intGpu.ToString();

            return (false);
        }
        private async Task<bool> CheckSd(bool mb = true)
        {
            if (txtMdl_d.Text.Trim() == "")
            {
                if (!mb) return (true);  //メッセージBOX非表示モードの時はエラーにする
            }
            else
            {
                if (!File.Exists(txtMdl_d.Text))
                {
                    if (mb) await MessageBox_Show("Stable Diffusion Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }
            if (txtVae.Text.Trim() != "")
            {
                if (!File.Exists(txtVae.Text))
                {
                    if (mb) await MessageBox_Show("Vae file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }
            if (txtEmb.Text.Trim() != "")
            {
                if (!File.Exists(txtEmb.Text))
                {
                    if (mb) await MessageBox_Show("Embedding file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }

            return (false);
        }
        private async Task<bool> CheckLv(bool mb = true)
        {
            //パラメータチェック
            if (txtMdl_l.Text.IndexOf("\'")>0 || txtMdl_l.Text.IndexOf("\"")>0)
            {
                if (mb) await MessageBox_Show("LLM Path contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }

            if (txtMdl_l.Text.Trim() == "")
            {
                if (!mb) return (true);  //メッセージBOX非表示モードの時はエラーにする
            }
            else
            {
                if (!File.Exists(txtMdl_l.Text))
                {
                    if (mb) await MessageBox_Show("LLM Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (!File.Exists(txtClp.Text))
                {
                    if (mb) await MessageBox_Show("Clip Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }

            uint intCtx = 0;
            int intGpu = 0;
            float fltTmp = 0.0f;
            if (!uint.TryParse(txtCtx_l.Text, out intCtx)) intCtx = 0;
            if (intCtx == 0) intCtx = 512;
            if (!float.TryParse(txtTmp_l.Text, out fltTmp)) fltTmp = 0.0f;
            if (!int.TryParse(txtGpu_l.Text, out intGpu)) intGpu = 0;
            if (intGpu == 0) intGpu = 5;
            txtCtx_l.Text = intCtx.ToString();
            txtTmp_l.Text = fltTmp.ToString("F");
            txtGpu_l.Text = intGpu.ToString();

            return (false);
        }

        public MemoryStream CevioAI(string strMsg, string strCast, bool booPlay = true)
        {
            try
            {
                var ms = new MemoryStream();
                string strWavPath = GetStartupPath() + @"\output.wav";
                dynamic service = Activator.CreateInstance(Type.GetTypeFromProgID("CeVIO.Talk.RemoteService2.ServiceControl2V40"));
                service.StartHost(false);
                dynamic talker = Activator.CreateInstance(Type.GetTypeFromProgID("CeVIO.Talk.RemoteService2.Talker2V40"));
                talker.Cast = strCast;
                if (booPlay)
                {
                    dynamic result = talker.Speak(strMsg);
                    result.Wait();
                    ms.Dispose();
                    ms = null;
                }
                else
                {
                    dynamic result = talker.OutputWaveToFile(strMsg, strWavPath);
                    using (FileStream file = new FileStream(strWavPath, FileMode.Open, FileAccess.Read))
                        file.CopyTo(ms);
                }
                //開放忘れるとメモリリーク
                System.Runtime.InteropServices.Marshal.ReleaseComObject(talker);
                System.Runtime.InteropServices.Marshal.ReleaseComObject(service);
                return ms;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return null;
            }
        }

        public void InitVoicevox(uint intSpeaker)
        {
            MainForm me = new MainForm();
            core = me.GetDefaultCoreObject();
            core.LoadModel(intSpeaker);
        }
        public MemoryStream Voicevox(string strMsg, uint intSpeaker, bool booPlay = true)
        {
            try
            {
                //MainForm me = new MainForm();
                //Core core = me.GetDefaultCoreObject();
                //core.LoadModel(intSpeaker);
                AudioQueryOptions audioQueryOptions = new AudioQueryOptions()
                {
                    kana = false
                };
                bool enableInterrogativeUpspeak = false;
                string json = core.AudioQuery(strMsg, intSpeaker, audioQueryOptions);
                SynthesisOptions synthesisOptions = new SynthesisOptions()
                {
                    enable_interrogative_upspeak = enableInterrogativeUpspeak
                };
                // When
                byte[] wavData = core.Synthesis(json, intSpeaker, synthesisOptions);
                MemoryStream ms = new MemoryStream(wavData);
                if (booPlay)
                {
                    var player = new SoundPlayer(ms);
                    player.PlaySync();
                    ms.Dispose();
                    ms = null;
                }
                return ms;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return null;
            }
        }
        public Core GetDefaultCoreObject()
        {
            InitializeOptions options = new InitializeOptions(GetOpenJtalkDictDir());
            options.LoadAllModels = false;
            return new Core(options);
        }
        public string GetOpenJtalkDictDir()
        {
            return System.IO.Path.Combine(GetThisAppDirectory() ?? "", "open_jtalk_dic_utf_8-1.11");
        }
        static public Assembly GetThisAssembly()
        {
            return Assembly.GetExecutingAssembly();
        }
        static public string? GetThisAppDirectory()
        {
            string appPath = GetThisAssembly().Location;
            return System.IO.Path.GetDirectoryName(appPath);
        }
        private void GPU_UsageMemory()
        {
            try
            {
                var category = new PerformanceCounterCategory("GPU Adapter Memory");
                var counterNames = category.GetInstanceNames();
                var gpuCountersDedicated = new List<PerformanceCounter>();
                var gpuCountersShared = new List<PerformanceCounter>();
                var result = 0f;
                double GpuUse = 0d;
                foreach (string counterName in counterNames)
                {
                    foreach (var counter in category.GetCounters(counterName))
                    {
                        if (counter.CounterName == "Dedicated Usage")
                        {
                            gpuCountersDedicated.Add(counter);
                        }
                    }
                }
                gpuCountersDedicated.ForEach(x =>
                {
                    _ = x.NextValue();
                });
                Task.Delay(1000);
                gpuCountersDedicated.ForEach(x =>
                {
                    result += x.NextValue();
                });
                double usage = (double)result;
                GpuUse = Math.Round(usage / 107374182.4, MidpointRounding.AwayFromZero);
                GpuUse = GpuUse / 10;
                lblGpu.Content = $"{GpuUse.ToString("F")} GB";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
        private async void DiscordBot()
        {
            if (string.IsNullOrWhiteSpace(strTkn))
            {
                Console.WriteLine("Please specify a token in the DISCORD_TOKEN environment variable.");
                Environment.Exit(1);
                return;
            }
            dcconfig = new()
            {
                Token = strTkn,
                TokenType = TokenType.Bot,
                Intents = DiscordIntents.AllUnprivileged | DiscordIntents.MessageContents | DiscordIntents.GuildVoiceStates
            };
            dcclient = new(dcconfig);
            dcclient.UseVoiceNext();

            //メッセージイベント
            dcclient.MessageCreated += OnMessageCreated;
            dcclient.Ready += OnClientReady;
            dcclient.GuildAvailable += OnGuildAvailable;
            dcclient.VoiceStateUpdated += OnVoiceStateUpdated;

            dcstatus = new("with fire", DSharpPlus.Entities.ActivityType.Playing);
            await dcclient.ConnectAsync(dcstatus, UserStatus.Online);
            picDc.Visibility = Visibility.Visible;
        }
        private async Task OnMessageCreated(DiscordClient client, MessageCreateEventArgs e)
        {
            //ボットに応答しない
            if (e.Message.Author.Id==client.CurrentUser.Id) return;
            //ターゲットチャンネル
            if (lngCid != 0 && e.Channel.Id != lngCid) return;
            if (!Wt)
            {
                Wt = true;
                ChatHistory.Message msg = new(AuthorRole.User, "User: " + e.Message.Content);
                WriteHistory(AuthorRole.User, e.Message.Content);
                Dispatcher.Invoke(dvwMsg_Refresh);
                // 回答の表示
                string strMsg = "";
                await foreach (string strAns in chtSess.ChatAsync(msg, infPara)) strMsg += strAns;
                //発信するときは「User:」や「Assistant:」を抜く
                string strSndmsg = EditAiMsg(strMsg);
                await e.Message.RespondAsync(strSndmsg);
                WriteHistory(AuthorRole.Assistant, strSndmsg);
                Dispatcher.Invoke(dvwMsg_Refresh);
                if (dcvoiceCon is not null) //Voiceチャンネルが開いているときは音声を送信
                {
                    MemoryStream msRes = SpeechSynthesis(strSndmsg, false);
                    await SendAsync(dcvoiceCon, msRes);
                }
                Wt = false;
            }
        }

        private Task OnClientReady(DiscordClient client, ReadyEventArgs e)
        {
            Console.WriteLine("Bot is ready!");
            return Task.CompletedTask;
        }

        private Task OnGuildAvailable(DiscordClient client, GuildCreateEventArgs e)
        {
            Console.WriteLine($"Guild available: {e.Guild.Name}");
            return Task.CompletedTask;
        }

        private async Task OnVoiceStateUpdated(DiscordClient client, VoiceStateUpdateEventArgs e)
        {
            try
            {
                //Bot以外のチャンネルが開いた場合
                if (e.After.Channel != null && !e.After.User.IsBot)
                {
                    Console.WriteLine($"{e.After.User.Username} joined voice channel {e.After.Channel.Name}");

                    var vnext = client.GetVoiceNext();
                    var connection = await vnext.ConnectAsync(e.After.Channel);

                    dcvoiceCon = connection;

                }
                //Botが退出した場合はコネクションをNULLにする
                if (e.After.Channel == null && e.After.User.IsBot)
                {
                    dcvoiceCon = null;
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }
        private async Task SendAsync(VoiceNextConnection connection, MemoryStream ms)
        {
            try
            {
                var transmit = connection.GetTransmitSink();
                var pcm = ConvertAudioToPcm(ms);
                await pcm.CopyToAsync(transmit);
                await pcm.DisposeAsync();
                ms.Close();
                ms.Dispose();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }
        private Stream ConvertAudioToPcm(MemoryStream ms)
        {
            try
            {
                var ffmpeg = Process.Start(new ProcessStartInfo
                {
                    FileName = "ffmpeg",
                    Arguments = $@"-i pipe:0 -ac 2 -f s16le -ar 48000 pipe:1",
                    RedirectStandardInput = true,
                    RedirectStandardOutput = true,
                    UseShellExecute = false
                });

                ffmpeg.StandardInput.BaseStream.WriteAsync(ms.ToArray(), 0, (int)ms.Length);
                ffmpeg.StandardInput.BaseStream.FlushAsync();
                return ffmpeg.StandardOutput.BaseStream;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
                return null;
            }
        }

        private MemoryStream SpeechSynthesis(string strMsg, bool booPlay = true)
        {
            switch (intCboSyt) //音声ソフト選択
            {
                case 1:
                    return CevioAI(strMsg, strCboCvo, booPlay);
                case 2:
                    return Voicevox(strMsg, intCboVvx, booPlay);
            }
            return null;
        }
        private int SearchEmotion(string strMsg)
        {
            //Smiling
            if (Regex.IsMatch(strMsg, "😀|😃|😄|😁|😆|😅|🤣|😂|🙂|🙃|😉|😊|😇")) return 1;
            //Affection
            if (Regex.IsMatch(strMsg, "🥰|😍|🤩|😘|😗|☺|😚|😙|🥲|💌|💘|💝|💖|💗|💓|💞|💕|💟|❣|❤|🧡|💛|💚|💙|💜|🤎|🖤|🤍|💋")) return 2;
            //Skeptical
            if (Regex.IsMatch(strMsg, "🤐|🤨|😐|😑|😶|😶‍🌫️|😏|😒|🙄|😬|😮‍💨|🤥")) return 3;
            //Concerned
            if (Regex.IsMatch(strMsg, "😕|😟|🙁|☹|😮|😯|😲|😳|🥺|🥹|😦|😧|😨|😰|😥|😢|😭|😱|😖|😣|😞|😓|😩|😫|🥱")) return 4;
            //Negative
            if (Regex.IsMatch(strMsg, "😤|😡|😠|🤬|😈|👿|💀|☠")) return 5;
            return 0;
        }
        private void btnEject_Click(object sender, RoutedEventArgs e)
        {
            ClearItems();
            SetEnabled_LoadGroup(true);
            dvwMsg.DataContext = null;
            SetEnabled_ChatGroup(false);
            booMic = false;
            chkMic.IsEnabled = false;
            lblSyt.Content = "";
            dvwMsg.AllowDrop = false;
            picEmt.Source = SelectEmtImg(0);
            GPU_UsageMemory(); //GPU使用メモリ編集
        }
        private void SetEnabled_LoadGroup(bool booIsEnabled)
        {
            btnLoad.IsEnabled = booIsEnabled;
            cboCht.IsEnabled = booIsEnabled;
            btnCht.IsEnabled = booIsEnabled;
            btnEdt.IsEnabled = booIsEnabled;
            btnSys.IsEnabled = booIsEnabled;
        }
        private void InitSettingEd()
        {
            try
            {
                btnUpd.IsEnabled = true;
                chkDel.IsEnabled = true;
                picUsu.ImageSource = new BitmapImage(new Uri(strEmtPath[0], UriKind.Relative));
                picSml.ImageSource = new BitmapImage(new Uri(strEmtPath[1], UriKind.Relative));
                picAfc.ImageSource = new BitmapImage(new Uri(strEmtPath[2], UriKind.Relative));
                picSkp.ImageSource = new BitmapImage(new Uri(strEmtPath[3], UriKind.Relative));
                picCnc.ImageSource = new BitmapImage(new Uri(strEmtPath[4], UriKind.Relative));
                picNeg.ImageSource = new BitmapImage(new Uri(strEmtPath[5], UriKind.Relative));
                txtMdl.AllowDrop = true;
                btnUsu.AllowDrop = true;
                btnSml.AllowDrop = true;
                btnAfc.AllowDrop = true;
                btnSkp.AllowDrop = true;
                btnCnc.AllowDrop = true;
                btnNeg.AllowDrop = true;
                chkDel.IsChecked = false;
                txtSeq.Text = "0";
                txtNam.Text = "";
                txtSys.Text = "";
                txtCtx.Text = "512";
                txtTmp.Text = "0.5";
                txtGpu.Text = "5";
                txtMdl.Text = "";
                cboSyt.SelectedIndex = 0;
                cboCvo.SelectedIndex = 0;
                cboVvx.SelectedIndex = 0;
                chkBot.IsChecked = false;
                txtTkn.Text = "";
                txtCid.Text = "";

                if (cboCht.SelectedIndex == -1)
                {
                    btnUpd.IsEnabled = false;
                    chkDel.IsEnabled = false;
                    AddcolMng();
                    AddcolMng2();
                    return;
                }
                txtSeq.Text = cboCht.SelectedValue.ToString();
                var conSb = new SQLiteConnectionStringBuilder { DataSource = DatabasePath };
                var con = new SQLiteConnection(conSb.ToString());
                bool dc = true;
                bool em = true;
                con.Open();
                using (var cmd = new SQLiteCommand(con))
                {
                    cmd.CommandText = $"select * from mng where no={txtSeq.Text}";
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            txtNam.Text = reader["nam"].ToString();
                            txtSys.Text = reader["sys"].ToString();
                            txtCtx.Text = reader["ctx"].ToString();
                            txtTmp.Text = reader["tmp"].ToString();
                            txtGpu.Text = reader["gpu"].ToString();
                            txtMdl.Text = reader["mdl"].ToString();
                            cboSyt.SelectedValue = reader["syt"];
                            intCboSyt = int.Parse(reader["syt"].ToString());
                            cboCvo.SelectedValue = reader["cvo"];
                            strCboCvo = reader["cvo"].ToString();
                            cboVvx.SelectedValue = reader["vvx"];
                            intCboVvx = uint.Parse(reader["vvx"].ToString());
                            if (reader.FieldCount >10)
                            {
                                chkBot.IsChecked = reader["bot"].ToString() == "1" ? true : false;
                                txtTkn.Text = reader["tkn"].ToString();
                                txtCid.Text = reader["cid"].ToString();
                            }
                            else dc = false;

                            if (reader.FieldCount >13)
                            {
                                if (reader["usu"].ToString() != "") picUsu.ImageSource = new BitmapImage(new Uri(reader["usu"].ToString(), UriKind.Relative));
                                if (reader["sml"].ToString() != "") picSml.ImageSource = new BitmapImage(new Uri(reader["sml"].ToString(), UriKind.Relative));
                                if (reader["afc"].ToString() != "") picAfc.ImageSource = new BitmapImage(new Uri(reader["afc"].ToString(), UriKind.Relative));
                                if (reader["skp"].ToString() != "") picSkp.ImageSource = new BitmapImage(new Uri(reader["skp"].ToString(), UriKind.Relative));
                                if (reader["cnc"].ToString() != "") picCnc.ImageSource = new BitmapImage(new Uri(reader["cnc"].ToString(), UriKind.Relative));
                                if (reader["neg"].ToString() != "") picNeg.ImageSource = new BitmapImage(new Uri(reader["neg"].ToString(), UriKind.Relative));
                            }
                            else em = false;

                            if (int.Parse(reader["syt"].ToString()) == 1) { lblSyt.Content = cboCvo.Text; }
                            if (int.Parse(reader["syt"].ToString()) == 2) { lblSyt.Content = cboVvx.Text; }
                        }
                    }
                }
                con.Close();

                if (!dc) AddcolMng();
                if (!em) AddcolMng2();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private async void InitSettingSys()
        {
            txtCtx_s.AllowDrop = true;
            txtTmp_s.AllowDrop = true;
            txtGpu_s.AllowDrop = true;
            txtMdl_s.AllowDrop = true;
            txtMdl_d.AllowDrop = true;
            txtVae.AllowDrop = true;
            txtEmb.AllowDrop = true;
            txtCtx_l.AllowDrop = true;
            txtTmp_l.AllowDrop = true;
            txtGpu_l.AllowDrop = true;
            txtMdl_l.AllowDrop = true;
            txtClp.AllowDrop = true;
            try
            {
                var conSb = new SQLiteConnectionStringBuilder { DataSource = DatabasePath };
                var con = new SQLiteConnection(conSb.ToString());
                con.Open();
                using (var cmd = new SQLiteCommand(con))
                {
                    cmd.CommandText = $"select * from sum where no=1";
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            txtCtx_s.Text = reader["ctx"].ToString();
                            txtTmp_s.Text = reader["tmp"].ToString();
                            txtGpu_s.Text = reader["gpu"].ToString();
                            txtMdl_s.Text = reader["mdl"].ToString();
                        }
                        reader.Close();
                    }
                    cmd.CommandText = $"select * from sd where no = 1";
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            txtMdl_d.Text = reader["mdl"].ToString();
                            txtVae.Text = reader["vae"].ToString();
                            txtEmb.Text = reader["emb"].ToString();
                        }
                        reader.Close();
                    }

                    cmd.CommandText = $"CREATE TABLE IF NOT EXISTS \"llv\" (" +
                        "\"no\"  INTEGER NOT NULL DEFAULT 0," +
                        "\"tmp\" REAL NOT NULL DEFAULT 0," +
                        "\"gpu\" REAL NOT NULL DEFAULT 0," +
                        "\"ctx\" REAL NOT NULL DEFAULT 0," +
                        "\"mdl\" TEXT," +
                        "\"clp\" TEXT," +
                        "PRIMARY KEY(\"no\"))";
                    cmd.ExecuteNonQuery();

                    cmd.CommandText = $"select count(*) from llv Where no=1";
                    using (var reader = cmd.ExecuteReader())
                    {
                        long reccount = 0;
                        if (reader.Read()) reccount = (long)reader[0];
                        reader.Close();
                        if (reccount==0)
                        {
                            cmd.CommandText = $"insert into llv(tmp,gpu,ctx,mdl,clp) values(0.0,15,512,'','')";
                            cmd.ExecuteNonQuery();
                        }
                        reader.Close();
                    }
                    cmd.CommandText = $"select * from llv where no=1";
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            txtCtx_l.Text = reader["ctx"].ToString();
                            txtTmp_l.Text = reader["tmp"].ToString();
                            txtGpu_l.Text = reader["gpu"].ToString();
                            txtMdl_l.Text = reader["mdl"].ToString();
                            txtClp.Text = reader["clp"].ToString();
                        }
                        reader.Close();
                    }
                }
                con.Close();
                //ピクト表示
                picSm.Visibility = Visibility.Hidden;
                picSd.Visibility = Visibility.Hidden;
                picLv.Visibility = Visibility.Hidden;
                Sm = !await CheckSm(false);
                if (Sm) picSm.Visibility = Visibility.Visible;
                //Stable Diffusion設定チェック
                Sd = !await CheckSd(false);
                if (Sd) picSd.Visibility = Visibility.Visible;
                //Llva設定チェック
                Lv = !await CheckLv(false);
                if (Lv) picLv.Visibility = Visibility.Visible;

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "HistorySummary", MessageBoxButton.OK, MessageBoxImage.Error);
            }

        }

        private void AddcolMng()
        {
            ExcSql($"Alter Table mng ADD COLUMN \"bot\" INTEGER DEFAULT 0", false);
            ExcSql($"Alter Table mng ADD COLUMN \"tkn\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"cid\" TEXT DEFAULT \"0\"", false);
        }
        private void AddcolMng2()
        {

            ExcSql($"Alter Table mng ADD COLUMN \"usu\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"sml\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"afc\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"skp\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"cnc\" TEXT DEFAULT \"\"", false);
            ExcSql($"Alter Table mng ADD COLUMN \"neg\" TEXT DEFAULT \"\"", false);
        }
        private bool ExcSql(string strSql, bool Mb = true)
        {
            try
            {
                var conSb = new SQLiteConnectionStringBuilder { DataSource = DatabasePath };
                var con = new SQLiteConnection(conSb.ToString());
                con.Open();
                using (var cmd = new SQLiteCommand(con))
                {
                    cmd.CommandText = strSql;
                    cmd.ExecuteNonQuery();
                    con.Close();
                }
                return false;
            }
            catch (Exception ex)
            {
                if (Mb) MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return true;
            }
        }

        private async void txtMsg_KeyDown(object sender, KeyEventArgs e)
        {
            try
            {
                if (e.Key == Key.Enter)
                {
                    e.Handled = true;
                    // ユーザーからの質問
                    string strMsg = txtMsg.Text;
                    txtMsg.Text = "";
                    await Chat(strMsg);
                    if (Sd && Sdprompt != "")
                    {
                        SetEnabled_ChatGroup(false);
                        lblInfo.Content = "Now Generating Images...";
                        lblInfo.Visibility = Visibility.Visible;
                        DoEvents();
                        var aimgen = new AimGen();
                        aimgen.ModelPath = txtMdl_d.Text;
                        aimgen.VaePath = txtVae.Text;
                        aimgen.EmbPath = txtEmb.Text;
                        picPrv.ImageSource = (BitmapImage)aimgen.AimGenRun(Sdprompt);
                        if (!OpenMenu.IsChecked.Value) //サイドが閉まっていたら勝手に開ける
                        {
                            OpenMenu.IsChecked = true;
                            OpenMenu_Click(sender, e);
                        }
                        aimgen = null;
                        lblInfo.Visibility = Visibility.Hidden;
                        SetEnabled_ChatGroup(true);
                        Sdprompt = "";
                    }
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
                lblInfo.Visibility = Visibility.Hidden;
                SetEnabled_ChatGroup(true);
            }
        }

        private string OpenFile(string strFolder, string strTitle, string strInitFile, string strFilter)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.FileName = strInitFile;
            dialog.InitialDirectory = strFolder;
            dialog.FilterIndex = 2;
            dialog.Title = strTitle;
            dialog.RestoreDirectory = true;
            dialog.CheckFileExists = true;
            dialog.CheckPathExists = true;
            dialog.Filter = strFilter;
            if (dialog.ShowDialog() == true) return (dialog.FileName);
            return ("");
        }
        private void btnMdl_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtMdl.Text.ToString() != null) strFolder = System.IO.Path.GetDirectoryName(txtMdl.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors";
            string strRtn = OpenFile(strFolder, "Open Model File", txtMdl.Text.ToString(), strFilter);
            if (strRtn != "") txtMdl.Text = strRtn;
        }

        private void btnCvo_Click(object sender, RoutedEventArgs e)
        {
            CevioAI($"おはよう、こんにちは、こんばんは", cboCvo.SelectedValue.ToString());
        }

        private void btnVvx_Click(object sender, RoutedEventArgs e)
        {
            if (uint.Parse(cboVvx.SelectedValue.ToString()) != intVvx)
            {
                intVvx = uint.Parse(cboVvx.SelectedValue.ToString());
                InitVoicevox(intVvx);
            }
            Voicevox($"おはよう、こんにちは、こんばんは", uint.Parse(cboVvx.SelectedValue.ToString()));
        }
        private async void btnNew_Click(object sender, RoutedEventArgs e)
        {
            if (await CheckEd()) return;

            if (await MessageBox_Show("Add a new record. Are you sure?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No) return;
            //sql編集
            string strUsu = ((BitmapImage)picUsu.ImageSource).UriSource.OriginalString;
            if (strUsu != "") if (!File.Exists(strUsu)) strUsu = "";
            string strSml = ((BitmapImage)picSml.ImageSource).UriSource.OriginalString;
            if (strSml != "") if (!File.Exists(strSml)) strSml = "";
            string strAfc = ((BitmapImage)picAfc.ImageSource).UriSource.OriginalString;
            if (strAfc != "") if (!File.Exists(strAfc)) strAfc = "";
            string strSkp = ((BitmapImage)picSkp.ImageSource).UriSource.OriginalString;
            if (strSkp != "") if (!File.Exists(strSkp)) strSkp = "";
            string strCnc = ((BitmapImage)picCnc.ImageSource).UriSource.OriginalString;
            if (strCnc != "") if (!File.Exists(strCnc)) strCnc = "";
            string strNeg = ((BitmapImage)picNeg.ImageSource).UriSource.OriginalString;
            if (strNeg != "") if (!File.Exists(strNeg)) strNeg = "";
            string strSql = "insert into mng(tmp,gpu,ctx,sys,nam,syt,cvo,vvx,mdl,bot,tkn,cid,usu,sml,afc,skp,cnc,neg) values(" +
                            $"{txtTmp.Text}," +
                            $"{txtGpu.Text}," +
                            $"{txtCtx.Text}," +
                            $"'{txtSys.Text}'," +
                            $"'{txtNam.Text}'," +
                            $"{cboSyt.SelectedValue}," +
                            $"'{cboCvo.SelectedValue}'," +
                            $"{cboVvx.SelectedValue}," +
                            $"'{txtMdl.Text}'," +
                            $"{(chkBot.IsChecked.Value ? 1 : 0)}," +
                            $"'{txtTkn.Text}'," +
                            $"'{txtCid.Text}'," +
                            $"'{strUsu}'," +
                            $"'{strSml}'," +
                            $"'{strAfc}'," +
                            $"'{strSkp}'," +
                            $"'{strCnc}'," +
                            $"'{strNeg}')";
            ExcSql(strSql);
            ContentSelector.SelectedIndex = 0;
            Menu_Button_Click();
        }

        private async void btnUpd_Click(object sender, RoutedEventArgs e)
        {
            if (chkDel.IsChecked.Value)
            {
                if (await MessageBox_Show("Delete record. Are you sure?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No) return;
                string strSql = $"delete from mng where no={cboCht.SelectedValue}";
                if (ExcSql(strSql)) return;
                strSql = $"drop table ch{cboCht.SelectedValue}";
                ExcSql(strSql, false);
            }
            else
            {
                string strUsu = ((BitmapImage)picUsu.ImageSource).UriSource.OriginalString;
                if (strUsu != "") if (!File.Exists(strUsu)) strUsu = "";
                string strSml = ((BitmapImage)picSml.ImageSource).UriSource.OriginalString;
                if (strSml != "") if (!File.Exists(strSml)) strSml = "";
                string strAfc = ((BitmapImage)picAfc.ImageSource).UriSource.OriginalString;
                if (strAfc != "") if (!File.Exists(strAfc)) strAfc = "";
                string strSkp = ((BitmapImage)picSkp.ImageSource).UriSource.OriginalString;
                if (strSkp != "") if (!File.Exists(strSkp)) strSkp = "";
                string strCnc = ((BitmapImage)picCnc.ImageSource).UriSource.OriginalString;
                if (strCnc != "") if (!File.Exists(strCnc)) strCnc = "";
                string strNeg = ((BitmapImage)picNeg.ImageSource).UriSource.OriginalString;
                if (strNeg != "") if (!File.Exists(strNeg)) strNeg = "";

                string strTable = $"ch{cboCht.SelectedValue}";
                if (await CheckEd()) return;
                if (await MessageBox_Show("Update record. Are you sure?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No) return;
                string strSql = "update mng set " +
                                $"tmp={txtTmp.Text}," +
                                $"gpu={txtGpu.Text}," +
                                $"ctx={txtCtx.Text}," +
                                $"sys='{txtSys.Text}'," +
                                $"nam='{txtNam.Text}'," +
                                $"syt={cboSyt.SelectedValue}," +
                                $"cvo='{cboCvo.SelectedValue}'," +
                                $"vvx={cboVvx.SelectedValue}," +
                                $"mdl='{txtMdl.Text}'," +
                                $"bot={(chkBot.IsChecked.Value ? 1 : 0)}," +
                                $"tkn='{txtTkn.Text}'," +
                                $"cid='{txtCid.Text}'," +
                                $"usu='{strUsu}'," +
                                $"sml='{strSml}'," +
                                $"afc='{strAfc}'," +
                                $"skp='{strSkp}'," +
                                $"cnc='{strCnc}'," +
                                $"neg='{strNeg}'" +
                                $" where no={cboCht.SelectedValue}";
                ExcSql(strSql);
            }
            ContentSelector.SelectedIndex = 0;
            Menu_Button_Click();
        }

        private async void btnDh_Click(object sender, EventArgs e)
        {
            if (await MessageBox_Show("Are you sure you want to delete your chat history?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No) return;
            string strSql = $"drop table ch{cboCht.SelectedValue}";
            ExcSql(strSql, false);
            ContentSelector.SelectedIndex = 0;
            Menu_Button_Click();
        }


        private void btnMdl_s_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtMdl_s.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtMdl_s.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;";
            string strRtn = OpenFile(strFolder: strFolder, "Open Model File", txtMdl_s.Text.ToString(), strFilter);
            if (strRtn != "") txtMdl_s.Text = strRtn;
        }
        private void btnMdl_d_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtMdl_d.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtMdl_d.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;";
            string strRtn = OpenFile(strFolder: strFolder, "Open Model File", txtMdl_d.Text.ToString(), strFilter);
            if (strRtn != "") txtMdl_d.Text = strRtn;
        }
        private void btnVae_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtVae.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtVae.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;*.pt;";
            string strRtn = OpenFile(strFolder, "Open Vae Model File", txtVae.Text.ToString(), strFilter);
            if (strRtn != "") txtVae.Text = strRtn;
        }
        private void btnEmb_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtEmb.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtEmb.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;*.pt;";
            string strRtn = OpenFile(strFolder, "Open Emb Model File", txtEmb.Text.ToString(), strFilter);
            if (strRtn != "") txtEmb.Text = strRtn;
        }
        private void btnMdl_l_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtMdl_l.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtMdl_l.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;";
            string strRtn = OpenFile(strFolder: strFolder, "Open Model File", txtMdl_l.Text.ToString(), strFilter);
            if (strRtn != "") txtMdl_l.Text = strRtn;
        }
        private void btnClp_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtClp.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtClp.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;";
            string strRtn = OpenFile(strFolder: strFolder, "Open Clip Model File", txtClp.Text.ToString(), strFilter);
            if (strRtn != "") txtClp.Text = strRtn;
        }
        private async void btnUpd2_Click(object sender, RoutedEventArgs e)
        {
            //Summary Check
            if (await CheckSm()) return;
            //Stable diffusion Check
            if (await CheckSd()) return;
            //Llava Check
            if (await CheckLv()) return;
            //Update
            if (await MessageBox_Show("Update record. Are you sure?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No) return;
            string strSql = "";
            strSql = "update sum set " +
                        $"tmp={txtTmp_s.Text}," +
                        $"gpu={txtGpu_s.Text}," +
                        $"ctx={txtCtx_s.Text}," +
                        $"mdl='{txtMdl_s.Text}'" +
                        $" where no=1";
            if (ExcSql(strSql)) return;

            strSql = "update sd set " +
                        $"mdl='{txtMdl_d.Text}'," +
                        $"vae='{txtVae.Text}'," +
                        $"emb='{txtEmb.Text}'" +
                        $" where no = 1";
            if (ExcSql(strSql)) return;

            strSql = "update llv set " +
                        $"tmp={txtTmp_l.Text}," +
                        $"gpu={txtGpu_l.Text}," +
                        $"ctx={txtCtx_l.Text}," +
                        $"mdl='{txtMdl_l.Text}'," +
                        $"clp='{txtClp.Text}'" +
                        $" where no=1";
            ExcSql(strSql);

            ContentSelector.SelectedIndex = 0;
            Menu_Button_Click();
        }
        private void Window_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (e.ButtonState == MouseButtonState.Pressed)
                this.DragMove();
        }

        private void btnMin_Click(object sender, RoutedEventArgs e)
        {
            this.WindowState = WindowState.Minimized;
        }

        private void btnMax_Click(object sender, RoutedEventArgs e)
        {
            if (this.WindowState == WindowState.Normal)
                this.WindowState = WindowState.Maximized;
            else
                this.WindowState = WindowState.Normal;
        }

        private void btnCls_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Application.Current.Shutdown();
        }

        private async void silenceTimer_Tick(object sender, System.Timers.ElapsedEventArgs e)
        {
            try
            {
                silenceTimerCnt++;
                //AIから話しかける仕組み
                if (silenceTimerCnt == 3)
                {
                    Random rTalk = new Random();
                    if (rTalk.Next(0, 1) == 0) //乱数で0が出たら話しかける。トリガーは"？？"
                    {
                        await Chat("？？");
                    }
                }
                if (booMic)
                {
                    if (recognizer.State == SpeechRecognizerState.Idle)
                    {
                        await recognizer.ContinuousRecognitionSession.StartAsync();
                    }
                }
                else
                {
                    if (recognizer.State != SpeechRecognizerState.Idle)
                    {
                        await recognizer.ContinuousRecognitionSession.StopAsync();
                    }
                }

            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private async void chkMic_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (chkMic.IsChecked.Value)
                {
                    booMic = true;
                    if (recognizer.State == SpeechRecognizerState.Idle)
                    {
                        await recognizer.ContinuousRecognitionSession.StartAsync();
                    }
                    silenceTimer.Start();
                }
                else
                {
                    booMic = false;
                    if (recognizer.State != SpeechRecognizerState.Idle)
                    {
                        await recognizer.ContinuousRecognitionSession.StopAsync();
                    }
                    silenceTimer.Stop();
                }
            }
            catch (Exception ex)
            {
                if (ex.HResult == -2147199735) MessageBox.Show("Have you enabled the \"online speech recognition\" in Windows settings under Start > Settings > Privacy > Speech? And have you enabled the microphone under the app capabilites?", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                else MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                chkMic.IsChecked = false;
                chkMic.IsEnabled = false;
                booMic = false;
            }

        }

        private void btnUsu_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picUsu.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picUsu.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picUsu.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picUsu.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void btnSml_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picSml.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picSml.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picSml.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picSml.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void btnAfc_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picAfc.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picAfc.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picAfc.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picAfc.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void btnSkp_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picSkp.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picSkp.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picSkp.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picSkp.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void btnCnc_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picCnc.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picCnc.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picCnc.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picCnc.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void btnNeg_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picNeg.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picNeg.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picNeg.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picNeg.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void Picture_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop)) e.Effects = DragDropEffects.Copy;
        }

        private void picUsu_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picUsu.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private void picSml_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picSml.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private void picAfc_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picAfc.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private void picSkp_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picSkp.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private void picCnc_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picCnc.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private void picNeg_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picNeg.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
            }
        }

        private void btnPrv_Click(object sender, RoutedEventArgs e)
        {
            if (picPrv.ImageSource != null)
            {
                string rtn = SaveFile("", this.Title, "");
                if (rtn != "")
                {
                    using (var fileStream = new FileStream(rtn, FileMode.Create))
                    {
                        BitmapEncoder encoder = new PngBitmapEncoder();
                        encoder.Frames.Add(BitmapFrame.Create(picPrv.ImageSource as BitmapImage));
                        encoder.Save(fileStream);
                    }
                }
            }
        }
        private string SaveFile(string strFolder, string strTitle, string strInitFile)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.FileName = strInitFile;
            dialog.InitialDirectory = strFolder;
            dialog.FilterIndex = 2;
            dialog.Title = strTitle;
            dialog.RestoreDirectory = true;
            dialog.Filter = $"model png|*.png;";
            if (dialog.ShowDialog() == true) return (dialog.FileName);
            return ("");
        }
        private void dvwMsg_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            if (dvwMsg.SelectedItem != null)
            {
                if (((TextBlock)dvwMsg.Columns[0].GetCellContent(dvwMsg.SelectedItem)).Text == strAI)
                {
                    string strMsg = ((TextBlock)dvwMsg.Columns[1].GetCellContent(dvwMsg.SelectedItem)).Text;

                    //画像生成キーワード探索
                    if (strMsg.IndexOf("[")  != -1 && Sd)
                    {
                        var rgxRtn = new Regex(@"\[(.+?)\]").Matches(strMsg);
                        if (rgxRtn.Count > 0)
                        {
                            Sdprompt = rgxRtn[0].Value.Replace("[", "").Replace("]", "").Trim();
                            if (Sdprompt != "")
                            {
                                DoEvents();
                                SetEnabled_ChatGroup(false);
                                lblInfo.Content = "Now Generating Images...";
                                lblInfo.Visibility = Visibility.Visible;
                                DoEvents();
                                var aimgen = new AimGen();
                                aimgen.ModelPath = txtMdl_d.Text;
                                aimgen.VaePath = txtVae.Text;
                                aimgen.EmbPath = txtEmb.Text;
                                picPrv.ImageSource = (BitmapImage)aimgen.AimGenRun(Sdprompt);
                                if (!OpenMenu.IsChecked.Value) //サイドが閉まっていたら勝手に開ける
                                {
                                    OpenMenu.IsChecked = true;
                                    OpenMenu_Click(sender, e);
                                }
                                aimgen = null;
                                lblInfo.Visibility = Visibility.Hidden;
                                SetEnabled_ChatGroup(true);
                                Sdprompt = "";
                            }
                        }
                    }
                    else
                    {
                        picEmt.Source = SelectEmtImg(SearchEmotion(strMsg));
                        DoEvents();
                        if (!Wt)
                        {
                            Wt = true;
                            SpeechSynthesis(strMsg); //音声ソフト実行
                            Thread.Sleep(3000);
                            Wt = false;
                        }
                    }
                }
            }

        }

        private void dvwMsg_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop)) e.Effects = DragDropEffects.Copy;
        }

        private async void dvwMsg_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    var img = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                    img = null;
                    if (Lv)
                    {
                        DoEvents();
                        SetEnabled_ChatGroup(false);
                        lblInfo.Content = "Now Analyzing Images...";
                        lblInfo.Visibility = Visibility.Visible;
                        DoEvents();
                        var llv = new Llava();
                        llv.ModelPath = txtMdl_l.Text;
                        llv.ClipPath = txtClp.Text;
                        llv.ContextSize = uint.Parse(txtCtx_l.Text);
                        llv.GpuLayerCount = int.Parse(txtGpu_l.Text);
                        llv.Temperature = float.Parse(txtTmp_l.Text);
                        llv.SystemPrompt = txtSys.Text;
                        string strMsg = await llv.Run(strFiles[0]);
                        if (strMsg != "")
                            LlavaChat("何の画像かわかる？", strMsg);
                        lblInfo.Visibility = Visibility.Hidden;
                        SetEnabled_ChatGroup(true);
                        llv = null;
                    }
                }
            }
            catch (Exception ex)
            {
                string msg = ex.Message;
                lblInfo.Visibility = Visibility.Hidden;
                SetEnabled_ChatGroup(true);
            }
        }

        private void SetEnabled_ChatGroup(bool booIsEnabled)
        {
            btnEject.IsEnabled = booIsEnabled;
            dvwMsg.IsEnabled = booIsEnabled;
            txtMsg.IsEnabled = booIsEnabled;
            chkMic.IsEnabled = booIsEnabled;
        }

        private void LlavaChat(string strUserInput, string strAiInput)
        {
            try
            {
                if (!Wt)
                {
                    Wt = true;
                    chtHis.AddMessage(AuthorRole.User, strUserInput);
                    WriteHistory(AuthorRole.User, strUserInput);
                    Dispatcher.Invoke(dvwMsg_Refresh);
                    // 回答の表示
                    string strSndmsg = EditAiMsg(strAiInput);
                    chtHis.AddMessage(AuthorRole.Assistant, strAiInput);
                    WriteHistory(AuthorRole.Assistant, strSndmsg);
                    Dispatcher.Invoke(dvwMsg_Refresh);
                    if (booMic)
                    {
                        SpeechSynthesis(strSndmsg); //音声ソフト実行
                        Thread.Sleep(3000);
                    }
                    Wt = false;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void txtMsg_GotFocus(object sender, RoutedEventArgs e)
        {
            txtMsg.SelectAll();
        }

        private void txtNam_GotFocus(object sender, RoutedEventArgs e)
        {
            txtNam.SelectAll();
        }

        private void txtSys_GotFocus(object sender, RoutedEventArgs e)
        {
            txtSys.SelectAll();
        }

        private void txtCtx_GotFocus(object sender, RoutedEventArgs e)
        {
            txtCtx.SelectAll();
        }

        private void txtTmp_GotFocus(object sender, RoutedEventArgs e)
        {
            txtTmp.SelectAll();
        }

        private void txtGpu_GotFocus(object sender, RoutedEventArgs e)
        {
            txtGpu.SelectAll();
        }

        private void txtMdl_GotFocus(object sender, RoutedEventArgs e)
        {
            txtMdl.SelectAll();
        }

        private void txtTkn_GotFocus(object sender, RoutedEventArgs e)
        {
            txtTkn.SelectAll();
        }

        private void txtCid_GotFocus(object sender, RoutedEventArgs e)
        {
            txtCid.SelectAll();
        }

        private void txtMdl_d_GotFocus(object sender, RoutedEventArgs e)
        {
            txtMdl_d.SelectAll();
        }

        private void txtVae_GotFocus(object sender, RoutedEventArgs e)
        {
            txtVae.SelectAll();
        }

        private void txtEmb_GotFocus(object sender, RoutedEventArgs e)
        {
            txtEmb.SelectAll();
        }

        private void txtCtx_l_GotFocus(object sender, RoutedEventArgs e)
        {
            txtCtx_l.SelectAll();
        }

        private void txtTmp_l_GotFocus(object sender, RoutedEventArgs e)
        {
            txtTmp_l.SelectAll();
        }

        private void txtGpu_l_GotFocus(object sender, RoutedEventArgs e)
        {
            txtGpu_l.SelectAll();
        }

        private void txtMdl_l_GotFocus(object sender, RoutedEventArgs e)
        {
            txtMdl_l.SelectAll();
        }

        private void txtClp_GotFocus(object sender, RoutedEventArgs e)
        {
            txtClp.SelectAll();
        }

        private void txtCtx_s_GotFocus(object sender, RoutedEventArgs e)
        {
            txtCtx_s.SelectAll();
        }

        private void txtTmp_s_GotFocus(object sender, RoutedEventArgs e)
        {
            txtTmp_s.SelectAll();
        }

        private void txtGpu_s_GotFocus(object sender, RoutedEventArgs e)
        {
            txtGpu_s.SelectAll();
        }

        private void txtMdl_s_GotFocus(object sender, RoutedEventArgs e)
        {
            txtMdl_s.SelectAll();
        }

        private void chkMod_Checked(object sender, RoutedEventArgs e)
        {
            SetBaseColors();
        }
        private void txtModel_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop)) e.Effects = DragDropEffects.Copy;
        }

        private void txtMdl_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtMdl.Text = strFiles[0];
            }
        }

        private void txtMdl_s_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtMdl_s.Text = strFiles[0];
            }
        }

        private void txtMdl_d_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtMdl_d.Text = strFiles[0];
            }
        }

        private void txtVae_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtVae.Text = strFiles[0];
            }
        }

        private void txtEmb_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtEmb.Text = strFiles[0];
            }
        }

        private void txtMdl_l_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtMdl_l.Text = strFiles[0];
            }
        }

        private void txtClp_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtClp.Text = strFiles[0];
            }
        }

        private void txtModel_PreviewDragOver(object sender, DragEventArgs e)
        {
            e.Handled = true;
        }

        private async Task<MessageBoxResult> MessageBox_Show(string Message, string Title, MessageBoxButton MsgBoxButton, MessageBoxImage MsgBoxImage)
        {
            var msgbox = new MessageBoxLDG(Title, Message, MsgBoxButton, MsgBoxImage);
            var rtn = await dialogHost.ShowDialog(msgbox);
            if (rtn == null) return MessageBoxResult.Cancel;
            return (MessageBoxResult)rtn;
        }

        private void cboPrm_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            SetPrimaryColors();
        }

        private void SetBaseColors()
        {
            PaletteHelper palette = new PaletteHelper();
            Theme theme = palette.GetTheme();
            if (chkMod.IsChecked.Value)
            {
                theme.SetBaseTheme(BaseTheme.Light);
            }
            else
            {
                theme.SetBaseTheme(BaseTheme.Dark);
            }
            palette.SetTheme(theme);
        }

        private void SetPrimaryColors()
        {
            PaletteHelper palette = new PaletteHelper();
            Theme theme = palette.GetTheme();
            switch (cboPrm.SelectedIndex)
            {
                case 0:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Amber]);
                    break;
                case 1:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Blue]);
                    break;
                case 2:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.BlueGrey]);
                    break;
                case 3:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Brown]);
                    break;
                case 4:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Cyan]);
                    break;
                case 5:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.DeepOrange]);
                    break;
                case 6:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.DeepPurple]);
                    break;
                case 7:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Green]);
                    break;
                case 8:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Grey]);
                    break;
                case 9:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Indigo]);
                    break;
                case 10:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.LightBlue]);
                    break;
                case 11:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.LightGreen]);
                    break;
                case 12:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Lime]);
                    break;
                case 13:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Orange]);
                    break;
                case 14:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Pink]);
                    break;
                case 15:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Purple]);
                    break;
                case 16:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Red]);
                    break;
                case 17:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Teal]);
                    break;
                case 18:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Yellow]);
                    break;
            }
            palette.SetTheme(theme);
        }
        private async void btnColDel_Click(object sender, RoutedEventArgs e)
        {
            if (await MessageBox_Show("Delete Message. Are you sure?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.Yes)
            {
                if (dtCht.Rows[dvwMsg.SelectedIndex].RowState != DataRowState.Deleted)
                {
                    long lngSq = long.Parse(dtCht.Rows[dvwMsg.SelectedIndex][2].ToString());
                    chtHis.Messages.Remove(chtHis.Messages[dvwMsg.SelectedIndex + 1]);
                    dtCht.Rows[dvwMsg.SelectedIndex].Delete();
                    dtCht.AcceptChanges();
                    ExcSql($"update ch{cboCht.SelectedValue} set flg=1 where sq={lngSq}");
                }
            }
        }
    }
}