﻿using System.Windows;
using System.Windows.Controls;

namespace LLM_Doghouse
{
    /// <summary>
    /// MessageBoxLDG.xaml の相互作用ロジック
    /// </summary>
    public partial class MessageBoxLDG : UserControl
    {
        public MessageBoxLDG()
        {
            InitializeComponent();
        }

        public MessageBoxLDG(string title, string message, MessageBoxButton mbButton, MessageBoxImage mImage = MessageBoxImage.Hand) : this()
        {
            labelTitle.Content = title;
            labelMessage.Content = message;
            int iRow = GetRowNomber(message);
            labelMessage.Height = 30 + iRow * 20;

            switch (mbButton)
            {
                case MessageBoxButton.OK:
                    Cancel.Visibility = Visibility.Hidden;
                    Cancel.Width = 0;
                    Yes.Visibility = Visibility.Hidden;
                    Yes.Width = 0;
                    No.Visibility = Visibility.Hidden;
                    No.Width = 0;
                    break;
                case MessageBoxButton.OKCancel:
                    Yes.Visibility = Visibility.Hidden;
                    Yes.Width = 0;
                    No.Visibility = Visibility.Hidden;
                    No.Width = 0;
                    break;
                case MessageBoxButton.YesNo:
                    OK.Visibility = Visibility.Hidden;
                    OK.Width = 0;
                    Cancel.Visibility = Visibility.Hidden;
                    Cancel.Width = 0;
                    break;
                case MessageBoxButton.YesNoCancel:
                    OK.Visibility = Visibility.Hidden;
                    OK.Width = 0;
                    Cancel.Visibility = Visibility.Hidden;
                    Cancel.Width = 0;
                    break;
            }
            imgErr.Width = 0;
            imgInf.Width = 0;
            imgQ.Width = 0;
            imgErr.Visibility = Visibility.Hidden;
            imgInf.Visibility = Visibility.Hidden;
            imgQ.Visibility = Visibility.Hidden;
            switch (mImage) 
            {
                case MessageBoxImage.Question:
                    imgQ.Width = 50;
                    imgQ.Visibility = Visibility.Visible;
                    break;
                case MessageBoxImage.Information:
                    imgInf.Width = 50;
                    imgInf.Visibility = Visibility.Visible;
                    break;
                case MessageBoxImage.Error:
                    imgErr.Width = 50;
                    imgErr.Visibility = Visibility.Visible;
                    break;
            }
        }

        public MessageBoxLDG(string title, string message) : this(title, message, MessageBoxButton.OK ,MessageBoxImage.Hand)
        {
        }

        private int GetRowNomber(string str)
        {
            string before = str;
            string after = str.Replace("\n", "");
            int ret = before.Length - after.Length;
            return ret;
        }
    }
}
